Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceProvider.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceProvider.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPInstanceProvider.cs	(revision 7538)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.ElloumiCTAP {
-  public class ElloumiCTAPInstanceProvider : ProblemInstanceProvider<ICTAPInstance> {
+  public class ElloumiCTAPInstanceProvider : ProblemInstanceProvider<CTAPInstance> {
     public override string Name {
       get { return "Elloumi's CTAP instances"; }
@@ -62,18 +62,11 @@
     }
 
-    public override ICTAPInstance GetInstance(IInstanceDescriptor id) {
+    public override CTAPInstance LoadInstance(IInstanceDescriptor id) {
       var descriptor = (ElloumiCTAPInstanceDescriptor)id;
-      var instance = new ElloumiCTAPInstance();
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
-        ElloumiCTAPParser datParser = new ElloumiCTAPParser();
-        datParser.Parse(stream);
-        if (datParser.Error != null) throw datParser.Error;
-        instance.Processors = datParser.Processors;
-        instance.Tasks = datParser.Tasks;
-        instance.ExecutionCosts = datParser.ExecutionCosts;
-        instance.CommunicationCosts = datParser.CommunicationCosts;
-        instance.MemoryRequirements = datParser.MemoryRequirements;
-        instance.MemoryCapacities = datParser.MemoryCapacities;
+        var parser = new ElloumiCTAPParser();
+        parser.Parse(stream);
+        var instance = Load(parser);
 
         instance.Name = id.Name;
@@ -91,5 +84,29 @@
           }
         }
+        return instance;
       }
+    }
+
+    public override CTAPInstance LoadInstance(string path) {
+      var parser = new ElloumiCTAPParser();
+      parser.Parse(path);
+      var instance = Load(parser);
+      instance.Name = Path.GetFileName(path);
+      instance.Description = "Loaded from file \"" + path + "\" on " + DateTime.Now.ToString();
+      return instance;
+    }
+
+    public override void SaveInstance(CTAPInstance instance, string path) {
+      throw new NotSupportedException();
+    }
+
+    private CTAPInstance Load(ElloumiCTAPParser parser) {
+      var instance = new CTAPInstance();
+      instance.Processors = parser.Processors;
+      instance.Tasks = parser.Tasks;
+      instance.ExecutionCosts = parser.ExecutionCosts;
+      instance.CommunicationCosts = parser.CommunicationCosts;
+      instance.MemoryRequirements = parser.MemoryRequirements;
+      instance.MemoryCapacities = parser.MemoryCapacities;
       return instance;
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPParser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPParser.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/ElloumiCTAPParser.cs	(revision 7538)
@@ -32,5 +32,4 @@
     public double[] MemoryRequirements { get; private set; }
     public double[] MemoryCapacities { get; private set; }
-    public Exception Error { get; private set; }
 
     public ElloumiCTAPParser() {
@@ -45,10 +44,9 @@
       MemoryRequirements = null;
       MemoryCapacities = null;
-      Error = null;
     }
 
-    public bool Parse(string file) {
+    public void Parse(string file) {
       using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
-        return Parse(stream);
+        Parse(stream);
       }
     }
@@ -62,54 +60,47 @@
     /// <param name="stream">The stream to read data from.</param>
     /// <returns>True if the file was successfully read or false otherwise.</returns>
-    public bool Parse(Stream stream) {
-      Error = null;
+    public void Parse(Stream stream) {
       var separator = new char[] { ' ', '\t' };
-      try {
-        StreamReader reader = new StreamReader(stream);
-        string line = Continue(reader);
+      var reader = new StreamReader(stream);
+      string line = Continue(reader);
 
-        Tasks = int.Parse(line);
+      Tasks = int.Parse(line);
 
+      line = Continue(reader);
+
+      Processors = int.Parse(line);
+
+      line = Continue(reader);
+
+      ExecutionCosts = new double[Processors, Tasks];
+      for (int i = 0; i < Processors; i++) {
+        string[] costsPerTask = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+        for (int j = 0; j < Tasks; j++)
+          ExecutionCosts[i, j] = double.Parse(costsPerTask[j], CultureInfo.InvariantCulture.NumberFormat);
         line = Continue(reader);
+      }
 
-        Processors = int.Parse(line);
+      CommunicationCosts = new double[Tasks, Tasks];
+      for (int i = 0; i < Tasks - 1; i++) {
+        string[] costsTaskToTasks = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+        for (int j = i + 1; j < Tasks; j++) {
+          CommunicationCosts[i, j] = double.Parse(costsTaskToTasks[j - i - 1], CultureInfo.InvariantCulture.NumberFormat);
+          CommunicationCosts[j, i] = CommunicationCosts[i, j];
+        }
+        line = Continue(reader);
+      }
 
-        line = Continue(reader);
+      MemoryRequirements = new double[Tasks];
+      string[] requirementsPerTask = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+      for (int i = 0; i < Tasks; i++)
+        MemoryRequirements[i] = double.Parse(requirementsPerTask[i], CultureInfo.InvariantCulture.NumberFormat);
 
-        ExecutionCosts = new double[Processors, Tasks];
-        for (int i = 0; i < Processors; i++) {
-          string[] costsPerTask = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
-          for (int j = 0; j < Tasks; j++)
-            ExecutionCosts[i, j] = double.Parse(costsPerTask[j], CultureInfo.InvariantCulture.NumberFormat);
-          line = Continue(reader);
-        }
+      line = Continue(reader);
 
-        CommunicationCosts = new double[Tasks, Tasks];
-        for (int i = 0; i < Tasks - 1; i++) {
-          string[] costsTaskToTasks = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
-          for (int j = i + 1; j < Tasks; j++) {
-            CommunicationCosts[i, j] = double.Parse(costsTaskToTasks[j - i - 1], CultureInfo.InvariantCulture.NumberFormat);
-            CommunicationCosts[j, i] = CommunicationCosts[i, j];
-          }
-          line = Continue(reader);
-        }
+      MemoryCapacities = new double[Processors];
+      string[] capacitiesPerProcessor = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
+      for (int i = 0; i < Processors; i++)
+        MemoryCapacities[i] = double.Parse(capacitiesPerProcessor[i], CultureInfo.InvariantCulture.NumberFormat);
 
-        MemoryRequirements = new double[Tasks];
-        string[] requirementsPerTask = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
-        for (int i = 0; i < Tasks; i++)
-          MemoryRequirements[i] = double.Parse(requirementsPerTask[i], CultureInfo.InvariantCulture.NumberFormat);
-
-        line = Continue(reader);
-
-        MemoryCapacities = new double[Processors];
-        string[] capacitiesPerProcessor = line.Split(separator, StringSplitOptions.RemoveEmptyEntries);
-        for (int i = 0; i < Processors; i++)
-          MemoryCapacities[i] = double.Parse(capacitiesPerProcessor[i], CultureInfo.InvariantCulture.NumberFormat);
-
-        return true;
-      } catch (Exception e) {
-        Error = e;
-        return false;
-      }
     }
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.csproj	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.csproj	(revision 7538)
@@ -133,5 +133,4 @@
     <EmbeddedResource Include="Data\tassc2005De.dat" />
     <None Include="Plugin.cs.frame" />
-    <Compile Include="ElloumiCTAPInstance.cs" />
     <Compile Include="ElloumiCTAPInstanceDescriptor.cs" />
     <Compile Include="ElloumiCTAPInstanceProvider.cs" />
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/Plugin.cs.frame
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/Plugin.cs.frame	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.ElloumiCTAP/3.3/Plugin.cs.frame	(revision 7538)
@@ -25,4 +25,6 @@
   [Plugin("HeuristicLab.Problems.Instances.ElloumiCTAP", "3.3.6.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.Instances.ElloumiCTAP-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
   public class HeuristicLabProblemsInstancesElloumiCTAPPlugin : PluginBase {
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/HeuristicLab.Problems.Instances.QAPLIB-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/HeuristicLab.Problems.Instances.QAPLIB-3.3.csproj	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/HeuristicLab.Problems.Instances.QAPLIB-3.3.csproj	(revision 7538)
@@ -51,5 +51,4 @@
   <ItemGroup>
     <Compile Include="QAPLIBParser.cs" />
-    <Compile Include="QAPLIBInstance.cs" />
     <Compile Include="QAPLIBInstanceDescriptor.cs" />
     <Compile Include="QAPLIBSolutionParser.cs" />
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/Plugin.cs.frame
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/Plugin.cs.frame	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/Plugin.cs.frame	(revision 7538)
@@ -25,4 +25,6 @@
   [Plugin("HeuristicLab.Problems.Instances.QAPLIB", "3.3.6.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.Instances.QAPLIB-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
   public class HeuristicLabProblemsInstancesQAPLIBPlugin : PluginBase {
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceProvider.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceProvider.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBInstanceProvider.cs	(revision 7538)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.QAPLIB {
-  public class QAPLIBInstanceProvider : ProblemInstanceProvider<IQAPInstance> {
+  public class QAPLIBInstanceProvider : ProblemInstanceProvider<QAPInstance> {
     public override string Name {
       get { return "QAPLIB"; }
@@ -62,16 +62,11 @@
     }
 
-    public override IQAPInstance GetInstance(IInstanceDescriptor id) {
+    public override QAPInstance LoadInstance(IInstanceDescriptor id) {
       var descriptor = (QAPLIBInstanceDescriptor)id;
-      var instance = new QAPLIBInstance();
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
-        QAPLIBParser datParser = new QAPLIBParser();
-        datParser.Parse(stream);
-        if (datParser.Error != null) throw datParser.Error;
-        instance.Dimension = datParser.Size;
-        instance.Distances = datParser.Distances;
-        instance.Weights = datParser.Weights;
-
+        var parser = new QAPLIBParser();
+        parser.Parse(stream);
+        var instance = Load(parser);
         instance.Name = id.Name;
         instance.Description = id.Description;
@@ -80,5 +75,5 @@
           using (Stream solStream = Assembly.GetExecutingAssembly()
             .GetManifestResourceStream(descriptor.SolutionIdentifier)) {
-            QAPLIBSolutionParser slnParser = new QAPLIBSolutionParser();
+            var slnParser = new QAPLIBSolutionParser();
             slnParser.Parse(solStream, true);
             if (slnParser.Error != null) throw slnParser.Error;
@@ -88,5 +83,26 @@
           }
         }
+        return instance;
       }
+    }
+
+    public override QAPInstance LoadInstance(string path) {
+      var parser = new QAPLIBParser();
+      parser.Parse(path);
+      var instance = Load(parser);
+      instance.Name = Path.GetFileName(path);
+      instance.Description = "Loaded from file \"" + path + "\" on " + DateTime.Now.ToString();
+      return instance;
+    }
+
+    public override void SaveInstance(QAPInstance instance, string path) {
+      throw new NotSupportedException();
+    }
+
+    private QAPInstance Load(QAPLIBParser parser) {
+      var instance = new QAPInstance();
+      instance.Dimension = parser.Size;
+      instance.Distances = parser.Distances;
+      instance.Weights = parser.Weights;
       return instance;
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBParser.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBParser.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.QAPLIB/3.3/QAPLIBParser.cs	(revision 7538)
@@ -28,5 +28,4 @@
     public double[,] Distances { get; private set; }
     public double[,] Weights { get; private set; }
-    public Exception Error { get; private set; }
 
     public QAPLIBParser() {
@@ -38,10 +37,9 @@
       Distances = null;
       Weights = null;
-      Error = null;
     }
 
-    public bool Parse(string file) {
+    public void Parse(string file) {
       using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read)) {
-        return Parse(stream);
+        Parse(stream);
       }
     }
@@ -55,50 +53,32 @@
     /// <param name="stream">The stream to read data from.</param>
     /// <returns>True if the file was successfully read or false otherwise.</returns>
-    public bool Parse(Stream stream) {
-      Error = null;
-      try {
-        StreamReader reader = new StreamReader(stream);
-        Size = int.Parse(reader.ReadLine());
-        Distances = new double[Size, Size];
-        Weights = new double[Size, Size];
-        string valLine = null;
-        char[] delim = new char[] { ' ' };
-        int read = 0;
-        int k = 0;
-        while (k < Size) {
-          if (reader.EndOfStream) throw new InvalidDataException("Reached end of stream while reading first matrix.");
-          valLine = reader.ReadLine();
-          while (String.IsNullOrWhiteSpace(valLine)) valLine = reader.ReadLine();
-          string[] vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
-          foreach (string val in vals) {
-            Weights[k, read++] = double.Parse(val);
-            if (read == Size) {
-              read = 0;
-              k++;
-            }
+    public void Parse(Stream stream) {
+      var reader = new StreamReader(stream);
+      Size = int.Parse(reader.ReadLine());
+      Distances = new double[Size, Size];
+      Weights = new double[Size, Size];
+      char[] delim = new char[] { ' ' };
+
+      Distances = ParseMatrix(reader, delim);
+      Weights = ParseMatrix(reader, delim);
+    }
+
+    private double[,] ParseMatrix(StreamReader reader, char[] delim) {
+      int read = 0, k = 0;
+      double[,] result = new double[Size, Size];
+      while (k < Size) {
+        if (reader.EndOfStream) throw new InvalidDataException("Reached end of stream while reading second matrix.");
+        string valLine = reader.ReadLine();
+        while (String.IsNullOrWhiteSpace(valLine)) valLine = reader.ReadLine();
+        string[] vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
+        foreach (string val in vals) {
+          Distances[k, read++] = double.Parse(val);
+          if (read == Size) {
+            read = 0;
+            k++;
           }
         }
-
-        read = 0;
-        k = 0;
-
-        while (k < Size) {
-          if (reader.EndOfStream) throw new InvalidDataException("Reached end of stream while reading second matrix.");
-          valLine = reader.ReadLine();
-          while (String.IsNullOrWhiteSpace(valLine)) valLine = reader.ReadLine();
-          string[] vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
-          foreach (string val in vals) {
-            Distances[k, read++] = double.Parse(val);
-            if (read == Size) {
-              read = 0;
-              k++;
-            }
-          }
-        }
-        return true;
-      } catch (Exception e) {
-        Error = e;
-        return false;
       }
+      return result;
     }
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/HeuristicLab.Problems.Instances.TSPLIB-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/HeuristicLab.Problems.Instances.TSPLIB-3.3.csproj	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/HeuristicLab.Problems.Instances.TSPLIB-3.3.csproj	(revision 7538)
@@ -45,9 +45,6 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="TSPLIBATSPInstance.cs" />
     <Compile Include="TSPLIBATSPInstanceProvider.cs" />
-    <Compile Include="TSPLIBCVRPInstance.cs" />
     <Compile Include="TSPLIBCVRPInstanceProvider.cs" />
-    <Compile Include="TSPLIBTSPInstance.cs" />
     <Compile Include="TSPLIBInstanceDescriptor.cs" />
     <Compile Include="TSPLIBTSPInstanceProvider.cs" />
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/Plugin.cs.frame
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/Plugin.cs.frame	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/Plugin.cs.frame	(revision 7538)
@@ -25,4 +25,6 @@
   [Plugin("HeuristicLab.Problems.Instances.TSPLIB", "3.3.6.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.Instances.TSPLIB-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
   public class HeuristicLabProblemsInstancesTSPLIBPlugin : PluginBase {
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBATSPInstanceProvider.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBATSPInstanceProvider.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBATSPInstanceProvider.cs	(revision 7538)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.TSPLIB {
-  public class TSPLIBATSPInstanceProvider : ProblemInstanceProvider<IATSPInstance> {
+  public class TSPLIBATSPInstanceProvider : ProblemInstanceProvider<ATSPInstance> {
 
     public override string Name {
@@ -65,19 +65,9 @@
     }
 
-    public override IATSPInstance GetInstance(IInstanceDescriptor id) {
+    public override ATSPInstance LoadInstance(IInstanceDescriptor id) {
       var descriptor = (TSPLIBInstanceDescriptor)id;
-      var instance = new TSPLIBATSPInstance();
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
-        var parser = new TSPLIBParser(stream);
-        parser.Parse();
-        instance.Dimension = parser.Dimension;
-        instance.Coordinates = parser.DisplayVertices != null ? parser.DisplayVertices : parser.Vertices;
-        instance.Distances = parser.Distances;
-
-        instance.Name = parser.Name;
-        instance.Description = parser.Comment
-          + Environment.NewLine + Environment.NewLine
-          + GetDescription();
+        var instance = Load(new TSPLIBParser(stream));
 
         if (!String.IsNullOrEmpty(descriptor.SolutionIdentifier)) {
@@ -89,5 +79,29 @@
           }
         }
+        return instance;
       }
+    }
+
+    public override ATSPInstance LoadInstance(string path) {
+      return Load(new TSPLIBParser(path));
+    }
+
+    public override void SaveInstance(ATSPInstance instance, string path) {
+      throw new NotSupportedException();
+    }
+
+    private ATSPInstance Load(TSPLIBParser parser) {
+      var instance = new ATSPInstance();
+
+      parser.Parse();
+      instance.Dimension = parser.Dimension;
+      instance.Coordinates = parser.DisplayVertices != null ? parser.DisplayVertices : parser.Vertices;
+      instance.Distances = parser.Distances;
+
+      instance.Name = parser.Name;
+      instance.Description = parser.Comment
+        + Environment.NewLine + Environment.NewLine
+        + GetDescription();
+
       return instance;
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBCVRPInstanceProvider.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBCVRPInstanceProvider.cs	(revision 7537)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBCVRPInstanceProvider.cs	(revision 7538)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.TSPLIB {
-  public class TSPLIBCVRPInstanceProvider : ProblemInstanceProvider<ICVRPInstance> {
+  public class TSPLIBCVRPInstanceProvider : ProblemInstanceProvider<CVRPInstance> {
 
     public override string Name {
@@ -64,42 +64,9 @@
     }
 
-    public override ICVRPInstance GetInstance(IInstanceDescriptor id) {
+    public override CVRPInstance LoadInstance(IInstanceDescriptor id) {
       var descriptor = (TSPLIBInstanceDescriptor)id;
-      var instance = new TSPLIBCVRPInstance();
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
-        var parser = new TSPLIBParser(stream);
-        parser.Parse();
-        instance.Dimension = parser.Dimension;
-        instance.Coordinates = parser.Vertices != null ? parser.Vertices : parser.DisplayVertices;
-        instance.Distances = parser.Distances;
-        instance.Capacity = parser.Capacity.Value;
-        instance.Demands = parser.Demands;
-        switch (parser.EdgeWeightType) {
-          case TSPLIBEdgeWeightTypes.ATT:
-            instance.DistanceMeasure = CVRPDistanceMeasure.Att; break;
-          case TSPLIBEdgeWeightTypes.CEIL_2D:
-            instance.DistanceMeasure = CVRPDistanceMeasure.UpperEuclidean; break;
-          case TSPLIBEdgeWeightTypes.EUC_2D:
-          case TSPLIBEdgeWeightTypes.EUC_3D:
-            instance.DistanceMeasure = CVRPDistanceMeasure.RoundedEuclidean; break;
-          case TSPLIBEdgeWeightTypes.EXPLICIT:
-            instance.DistanceMeasure = CVRPDistanceMeasure.Direct; break;
-          case TSPLIBEdgeWeightTypes.GEO:
-            instance.DistanceMeasure = CVRPDistanceMeasure.Geo; break;
-          case TSPLIBEdgeWeightTypes.MAN_2D:
-          case TSPLIBEdgeWeightTypes.MAN_3D:
-            instance.DistanceMeasure = CVRPDistanceMeasure.Manhattan; break;
-          case TSPLIBEdgeWeightTypes.MAX_2D:
-          case TSPLIBEdgeWeightTypes.MAX_3D:
-            instance.DistanceMeasure = CVRPDistanceMeasure.Maximum; break;
-          default:
-            throw new InvalidDataException("The given edge weight is not supported by HeuristicLab.");
-        }
-
-        instance.Name = parser.Name;
-        instance.Description = parser.Comment
-          + Environment.NewLine + Environment.NewLine
-          + GetDescription();
+        var instance = Load(new TSPLIBParser(stream));
 
         if (!String.IsNullOrEmpty(descriptor.SolutionIdentifier)) {
@@ -111,5 +78,51 @@
           }
         }
+        return instance;
       }
+    }
+
+    public override CVRPInstance LoadInstance(string path) {
+      return Load(new TSPLIBParser(path));
+    }
+
+    public override void SaveInstance(CVRPInstance instance, string path) {
+      throw new NotSupportedException();
+    }
+
+    private CVRPInstance Load(TSPLIBParser parser) {
+      parser.Parse();
+      var instance = new CVRPInstance();
+      instance.Dimension = parser.Dimension;
+      instance.Coordinates = parser.Vertices != null ? parser.Vertices : parser.DisplayVertices;
+      instance.Distances = parser.Distances;
+      instance.Capacity = parser.Capacity.Value;
+      instance.Demands = parser.Demands;
+      switch (parser.EdgeWeightType) {
+        case TSPLIBEdgeWeightTypes.ATT:
+          instance.DistanceMeasure = CVRPDistanceMeasure.Att; break;
+        case TSPLIBEdgeWeightTypes.CEIL_2D:
+          instance.DistanceMeasure = CVRPDistanceMeasure.UpperEuclidean; break;
+        case TSPLIBEdgeWeightTypes.EUC_2D:
+        case TSPLIBEdgeWeightTypes.EUC_3D:
+          instance.DistanceMeasure = CVRPDistanceMeasure.RoundedEuclidean; break;
+        case TSPLIBEdgeWeightTypes.EXPLICIT:
+          instance.DistanceMeasure = CVRPDistanceMeasure.Direct; break;
+        case TSPLIBEdgeWeightTypes.GEO:
+          instance.DistanceMeasure = CVRPDistanceMeasure.Geo; break;
+        case TSPLIBEdgeWeightTypes.MAN_2D:
+        case TSPLIBEdgeWeightTypes.MAN_3D:
+          instance.DistanceMeasure = CVRPDistanceMeasure.Manhattan; break;
+        case TSPLIBEdgeWeightTypes.MAX_2D:
+        case TSPLIBEdgeWeightTypes.MAX_3D:
+          instance.DistanceMeasure = CVRPDistanceMeasure.Maximum; break;
+        default:
+          throw new InvalidDataException("The given edge weight is not supported by HeuristicLab.");
+      }
+
+      instance.Name = parser.Name;
+      instance.Description = parser.Comment
+        + Environment.NewLine + Environment.NewLine
+        + GetDescription();
+
       return instance;
     }
